twitch-simulator/Models/DefaultDbContext.cs
using Microsoft.EntityFrameworkCore;
using System;
using twitch.api;
using static Microsoft.EntityFrameworkCore.DbLoggerCategory.Database;


namespace twitch_simulator.Models
{
    public class DefaultDbContext : DbContext
    {
        public DbSet<Streamer> Streamers { get; set; }
        public DbSet<Follower> Followers { get; set; }
        public DbSet<twitch.api.Stream> Streams { get; set; }
        public DbSet<twitch.api.Session> Sessions { get; set; }

        public DefaultDbContext(DbContextOptions<DefaultDbContext> options) : base(options)
        {
        }

        protected DefaultDbContext()
        {
        }
    }
}

twitch-simulator/Models/ErrorViewModel.cs
namespace twitch_simulator.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

twitch-simulator/Controllers/FollowersController.cs
using dtos.api;
using twitch.api;
using Microsoft.AspNetCore.Mvc;
using twitch_simulator.Models;
using Microsoft.AspNetCore.Authorization;

namespace twitch_simulator.Controllers
{
    /// <summary>
    /// Controlleur followers
    /// Gere les interations avec le modele follower ou dérivés et la vue List et Edit de Follower 
    /// </summary>
    public class FollowersController : Controller
    {
        private readonly DefaultDbContext context;
        public FollowersController(DefaultDbContext context)
        {
            this.context = context;
        }

        /// <summary>
        /// Action de creation d'un nouveau follower et ajout au contexte
        /// Appel de la vue List
        /// </summary>
        /// <returns>Retourne vers la vue List</returns>
        [Authorize]
        [HttpPost]
        public IActionResult New()
        {
            this.context.Followers.Add(new Follower());
            this.context.SaveChanges();
            return RedirectToAction("List");
        }

        /// <summary>
        /// Action qui appelle la vue Edit de Follower
        /// recupere l'id du follower grace à la mathode GET
        /// </summary>
        /// <param name="id"></param>
        /// <returns>Retourne vers la vue Edit</returns>
        [Authorize]
        [HttpGet]
        public IActionResult Edit(int id)
        {
            Follower follower = this.context.Followers.Find(id);
            return View("Edit", follower);
        }


        /// <summary>
        /// Action de mise a jour d'un follower du contexte
        /// </summary>
        /// <param name="editFollower"></param>
        /// <returns>Appel de l'action liste</returns>
        [Authorize]
        [HttpPost]
        public IActionResult Edit(Follower editFollower)
        {
            Follower follower = this.context.Followers.Find(editFollower.Id);
            follower.Pseudo = editFollower.Pseudo;
            follower.Email = editFollower.Email;
            follower.ProfilePicture = editFollower.ProfilePicture;
            this.context.SaveChanges();
            return RedirectToAction("List");
        }

        /// <summary>
        /// Action de suppression d'un follower de la liste dans le contexte
        /// </summary>
        /// <param name="id">identitfiaant du follower</param>
        /// <returns>Appel de l'action List</returns>
        [Authorize]
        [HttpGet]
        public IActionResult Delete(int id)
        {
            Follower follower = this.context.Followers.Find(id);
            this.context.Followers.Remove(follower);
            this.context.SaveChanges();
            return RedirectToAction("List");
        }


        /// <summary>
        /// Action qui appelle la vue liste apres avoir recupere les followers du contexte
        /// </summary>
        /// <returns></returns>
        [Authorize]
        public IActionResult List()
        {
            var query = from follower in this.context.Followers select follower;
            return View("List", query.ToList());
        }

        /// <summary>
        /// Action qui fait la liste des followers apres une mise a jour du statut d'un follower 
        /// </summary>
        /// <param name="editFollower"></param>
        /// <returns>Retourne vers la vue List</returns>
        [Authorize]
        [HttpPost]
        public IActionResult List(Follower editFollower)
        {
            var follower = this.context.Followers.Find(editFollower.Id);
            if (follower.IsConnected)
            {
                var currentFollowerSession = this.context.Sessions.FirstOrDefault(session => session.FollowerId == follower.Id && session.End == null);
                currentFollowerSession.End = DateTime.Now;
                follower.IsConnected = false;
            }
            else
            {
                this.context.Sessions.Add(new Session(follower.Id));
                follower.IsConnected = true;
            }
            this.context.SaveChanges();
            return RedirectToAction("List");
        }
    }
}

twitch-simulator/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;
using twitch_simulator.Models;

namespace twitch_simulator.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

twitch-simulator/Controllers/StreamController.cs
using dtos.api;
using Stream = twitch.api.Stream;
using Microsoft.AspNetCore.Mvc;
using twitch_simulator.Models;
using Microsoft.AspNetCore.Authorization;

namespace twitch_simulator.Controllers
{
    public class StreamController : Controller
    {
        private readonly DefaultDbContext context;
        public StreamController(DefaultDbContext context)
        {
            this.context = context;
        }

        [Authorize]
        public IActionResult List()
        {
            var query = from stream in this.context.Streams select new StreamDTO(stream);
             

            return View("List", query.ToList());
        }

        [Authorize]
        [HttpGet]
        public IActionResult Stop(int id)
        {
            Stream stream = this.context.Streams.Find(id);
            stream.End = DateTime.Now;
            this.context.SaveChanges();
            return RedirectToAction("List");
        }

        [Authorize]
        [HttpGet]
        public IActionResult Start(int id)
        {
            Stream stream = this.context.Streams.Find(id);
            stream.Start = DateTime.Now;
            stream.End = null;
            this.context.SaveChanges();
            return RedirectToAction("List");
        }

        [Authorize]
        [HttpPost]
        public IActionResult New()
        {
            this.context.Streams.Add(new Stream());
            this.context.SaveChanges();
            return RedirectToAction("List");
        }
        [Authorize]
        [HttpGet]
        public IActionResult Delete(int id)
        {
            Stream stream = this.context.Streams.Find(id);
            this.context.Streams.Remove(stream);
            this.context.SaveChanges();
            return RedirectToAction("List");
        }


        [Authorize]
        [HttpGet]
        public IActionResult Edit(int id)
        {
            Stream stream = this.context.Streams.Find(id);
            return View("Edit", stream);
        }

        [Authorize]
        [HttpPost]
        public IActionResult Edit(Stream editStream)
        {
            Stream stream = this.context.Streams.Find(editStream.Id);
            stream.Title = editStream.Title;
            stream.Start = editStream.Start;
            stream.End = null;
            this.context.SaveChanges();
            return RedirectToAction("List");
        }


    }
}

twitch-simulator/Views/Followers/Edit.cshtml
@using twitch.api;
@model Follower
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}
<h1>Follower edition</h1>
<form asp-action="Edit" asp-controller="Followers" method="post">
    <div class="mb-3">
        <label class="form-label">Pseudo:</label>
        <input type="text" name="Pseudo" value="@Model.Pseudo"/>
        <label class="form-label">Email:</label>
        <input type="email" name="Email" value="@Model.Email"/>
        <label class="form-label">ProfilePicture:</label>
        <input type="text" name="ProfilePicture" value="@Model.ProfilePicture" required/>
        <input type="hidden" name="Id" value=@Model.Id />
    </div>
    <button type="submit" class="btn btn-primary">Submit</button>
</form>

twitch-simulator/Views/Followers/List.cshtml
@using twitch.api;
@model List<Follower>
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<h1>Followers</h1>
<form asp-action="New" asp-controller="Followers" method="post">
    <button type="submit" class="btn btn-outline-primary">New</button>
</form>
<table class="table">
    <tr>
        <th>Pseudo</th>
        <th>Profile Picture</th>
        <th>Status</th>
        <th>Stream</th>
    </tr>
    <tbody>
        @foreach (var follower in Model)
        {
            <tr>
                <td>
                    @if (follower.Pseudo == null)
                    {
                        @follower.Id
                    }
                    else @follower.Pseudo
                </td>
                <td><img src="@follower.ProfilePicture") width="60" height="60"/></td>
                <td>
                    <form asp-action="List" asp-controller="Followers" class="follower-status-form" id="follower-@follower.Id-status-form" method="post">
                        <input type="hidden" name="Id" value="@follower.Id" />
                        @if (follower.IsConnected) 
                        {
                            <div class="form-check">
                                <input class="form-check-input" type="checkbox" id="flexCheckConnected-@follower.Id" checked>
                            <label class="form-check-label" for="flexCheckChecked-@follower.Id">
                                Connected
                            </label>
                        </div>   
                        }
                        else
                        {
                        <div class="form-check">                    
                            <input class="form-check-input" type="checkbox" id="flexCheckDisconnected-@follower.Id">
                            <label class="form-check-label" for="flexCheckDefault-@follower.Id">
                                Disconnected
                            </label>
                        </div>                     
                        }
                    </form> 
                </td>
                <td>
                    <div class="btn-group" role="group" aria-label="Basic example">
                        <form asp-action="Edit" asp-controller="Followers" method="get">
                            <input type="hidden" name="Id" value=@follower.Id />       
                            <button type="submit" class="btn btn-primary">Edit</button>
                        </form>
                        <form asp-action="Delete" asp-controller="Followers" method="get">
                            <input type="hidden" name="Id" value=@follower.Id />       
                            <button type="submit" class="btn btn-danger">Delete</button>
                        </form>
                    </div>
                </td>
            </tr>    
        }
        <script>
            const forms = document.querySelectorAll('.follower-status-form')
            Array.from(forms).forEach(form => {
                const checkbox = form.querySelector('.form-check-input')
                checkbox.addEventListener('change', (evt) => {
                    form.submit()
                })
            })              
        </script>
    </tbody>
</table>

twitch-simulator/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

twitch-simulator/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - twitch_simulator</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/twitch_simulator.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">twitch_simulator</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Stream" asp-action="List">Streams</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Followers" asp-action="List">Followers</a>
                        </li>
                    </ul>
                    <partial name="_LoginPartial" />
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - twitch_simulator - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

twitch-simulator/Views/Stream/Edit.cshtml
@using Stream = twitch.api.Stream;
@model Stream
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<h1>Stream edition</h1>
<form asp-action="Edit" asp-controller="Stream" method="post">
    <div class="mb-3">
        <label class="form-label">Title:</label>
        <input type="text" name="Title" value="@Model.Title" required/>
        <label class="form-label">Date:</label>
        <input type="datetime-local" name="Start" value="@Model.Start?.ToString("yyyy-MM-ddThh:mm")" required/>
        <input type="hidden" name="Id" value=@Model.Id />
    </div>
    <button type="submit" class="btn btn-primary">Submit</button>
</form>

twitch-simulator/Views/Stream/List.cshtml
@using dtos.api;
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

<h1>Streams</h1>
<form asp-action="New" asp-controller="Stream" method="post">
    <button type="submit" class="btn btn-outline-primary">New</button>
</form>


<table class="table">
    <tr>
        <th>Titre</th>
        <th>Creation Date</th>
        <th>Start Date</th>
        <th>End Date</th>
        <th>Statut</th>
    </tr>
    <tbody>
        @foreach (var stream in Model)
        {
                    <tr>
                        <td>@stream.Stream.Title</td>
                        <td>@stream.Stream.CreationDate</td>
                        <td>@stream.Stream.Start</td>
                        <td>@stream.Stream.End</td>
                        <td>@stream.Status</td>
                        <td>
                                <div class="btn-group" role="group" aria-label="Basic example">
                                    <form asp-action="Edit" asp-controller="Stream" method="get">
                                        <input type="hidden" name="Id" value=@stream.Stream.Id />       
                                        <button type="submit" class="btn btn-primary">Edit</button>
                                    </form>
                                    @if (stream.Status == StreamStatusType.Ended || stream.Status == StreamStatusType.Upcoming)
                                    {
                                        <form asp-action="Start" asp-controller="Stream" method="get">
                                            <input type="hidden" name="Id" value=@stream.Stream.Id />       
                                            <button type="submit" class="btn btn-success">Start</button>
                                        </form>
                                    }
                                    @if (stream.Status == StreamStatusType.InProgress)
                                    {
                                        <form asp-action="Stop" asp-controller="Stream" method="get">
                                            <input type="hidden" name="Id" value=@stream.Stream.Id />       
                                            <button type="submit" class="btn btn-warning">Stop</button>
                                        </form>
                                    }
                                    <form asp-action="Delete" asp-controller="Stream" method="get">
                                        <input type="hidden" name="Id" value=@stream.Stream.Id />       
                                        <button type="submit" class="btn btn-danger">Delete</button>
                                    </form>
                                </div>
                        </td>
                    </tr>    
        }
    </tbody>
</table>